DROP VIEW hotwire."30_Report/Source_of_Funds";
DROP VIEW hotwire."30_Report/Short_Searching";
DROP VIEW hotwire."30_Report/Searching";

CREATE OR REPLACE VIEW hotwire."30_Report/Searching" AS 
 SELECT (person.id || COALESCE(roles.post_category, ''::character varying)::text) || COALESCE(roles.start_date::text, ''::text) AS id, person.surname, person.first_names, person.title_id, person.known_as, person.gender_id, date_part('year'::text, age(person.date_of_birth::timestamp with time zone)) AS ro_age, person.arrival_date, person.leaving_date, _physical_status_v2.status_id AS physical_status_id, roles.start_date, roles.intended_end_date, roles.end_date, roles.funding_end_date, roles.post_category, roles.status AS role_status_id, roles.chem, person.date_of_birth, person.registration_completed, person.clearance_cert_signed, person.email_address, person.crsid, person.hide_email, ARRAY( SELECT mm_person_room.room_id
           FROM mm_person_room
          WHERE mm_person_room.person_id = person.id) AS room_id, person.location, ARRAY( SELECT mm_person_dept_telephone_number.dept_telephone_number_id
           FROM mm_person_dept_telephone_number
          WHERE mm_person_dept_telephone_number.person_id = person.id) AS dept_telephone_number_id, person.mobile_number, person.cambridge_phone_number, ARRAY( SELECT mm_person_research_group.research_group_id
           FROM mm_person_research_group
          WHERE mm_person_research_group.person_id = person.id) AS research_group_id, ARRAY( SELECT research_group.sector_id
           FROM mm_person_research_group
      JOIN research_group ON research_group.id = mm_person_research_group.research_group_id
     WHERE mm_person_research_group.person_id = person.id) AS sector_id, roles.supervisor_id, roles.manager_id, roles.paid_by_university, person.continuous_employment_start_date, person.payroll_personal_reference_number, person.paper_file_details, person.ni_number, roles.job_title, roles.current_funding, roles.research_grant_number, roles.university, ARRAY( SELECT mm_person_nationality.nationality_id
           FROM mm_person_nationality
          WHERE mm_person_nationality.person_id = person.id) AS nationality_id, person.cambridge_college_id, roles.cpgs_or_mphil_date_submission_due, roles.cpgs_or_mphil_date_submitted, roles.cpgs_or_mphil_date_awarded, roles.mphil_date_submission_due, roles.mphil_date_submitted, roles.mphil_date_awarded, roles.date_registered_for_phd, roles.phd_date_title_approved, roles.date_phd_submission_due, roles.phd_four_year_submission_date, roles.phd_date_submitted, roles.phd_date_examiners_appointed, roles.phd_date_of_viva, roles.phd_date_awarded, roles.co_supervisor_id, roles.mentor_id, roles.co_mentor_id, roles.gaf_number, roles.emplid_number, roles.cpgs_title_html, roles.mphil_title_html, roles.msc_title_html, roles.phd_thesis_title_html, roles.next_mentor_meeting_due, roles.fees_funding, roles.part_iii_project_title_html, roles.date_of_first_probation_meeting, roles.date_of_second_probation_meeting, roles.date_of_third_probation_meeting, roles.date_probation_letters_sent, roles.probation_period, person.usual_reviewer_id AS reviewer_id, roles.next_review_due, roles.timing_of_reviews, roles.transferable_skills_days_1st_year, roles.transferable_skills_days_2nd_year, roles.transferable_skills_days_3rd_year, roles.transferable_skills_days_4th_year, person.forwarding_address, person.emergency_contact, person.new_employer_address, person.cambridge_address, person.previous_surname, person.other_information::character varying(5000) AS other_information, person.notes::character varying(5000) AS notes, roles.progress_notes
   FROM person
   LEFT JOIN (        (        (        (         SELECT v.person_id, v.start_date, v.intended_end_date, v.end_date, NULL::date AS funding_end_date, false AS chem, _all_roles.post_category, NULL::text AS job_title, NULL::bigint AS manager_id, NULL::text AS progress_notes, v.host_person_id AS supervisor_id, NULL::text AS university, NULL::text AS gaf_number, NULL::bigint AS postgraduate_studentship_type_id, NULL::text AS cpgs_title_html, NULL::text AS mphil_title_html, NULL::text AS msc_title_html, NULL::date AS cpgs_or_mphil_date_submission_due, NULL::date AS cpgs_or_mphil_date_submitted, NULL::date AS cpgs_or_mphil_date_awarded, NULL::date AS mphil_date_submission_due, NULL::date AS mphil_date_submitted, NULL::date AS mphil_date_awarded, NULL::date AS date_registered_for_phd, NULL::text AS phd_thesis_title_html, NULL::date AS phd_date_title_approved, NULL::date AS date_phd_submission_due, NULL::date AS phd_four_year_submission_date, NULL::date AS phd_date_submitted, NULL::date AS phd_date_examiners_appointed, NULL::date AS phd_date_of_viva, NULL::date AS phd_date_awarded, NULL::bigint AS co_supervisor_id, NULL::bigint AS mentor_id, NULL::bigint AS co_mentor_id, NULL::date AS next_mentor_meeting_due, NULL::text AS current_funding, NULL::text AS fees_funding, NULL::text AS research_grant_number, NULL::text AS part_iii_project_title_html, NULL::boolean AS paid_by_university, NULL::date AS date_of_first_probation_meeting, NULL::date AS date_of_second_probation_meeting, NULL::date AS date_of_third_probation_meeting, NULL::date AS date_probation_letters_sent, NULL::text AS probation_period, NULL::text AS emplid_number, NULL::date AS next_review_due, NULL::text AS timing_of_reviews, NULL::real AS transferable_skills_days_1st_year, NULL::real AS transferable_skills_days_2nd_year, NULL::real AS transferable_skills_days_3rd_year, NULL::real AS transferable_skills_days_4th_year, _all_roles.status
                                           FROM visitorship v
                                      LEFT JOIN _all_roles_v12 _all_roles ON v.id = _all_roles.role_id
                                     WHERE _all_roles.role_tablename = 'visitorship'::text
                                UNION 
                                         SELECT e.person_id, e.start_date, e.intended_end_date, e.end_date, NULL::date AS funding_end_date, false AS chem, _all_roles.post_category, NULL::text AS job_title, NULL::bigint AS manager_id, NULL::text AS progress_notes, e.supervisor_id, e.university, NULL::text AS gaf_number, NULL::bigint AS postgraduate_studentship_type_id, NULL::text AS cpgs_title_html, NULL::text AS mphil_title_html, NULL::text AS msc_title_html, NULL::date AS cpgs_or_mphil_date_submission_due, NULL::date AS cpgs_or_mphil_date_submitted, NULL::date AS cpgs_or_mphil_date_awarded, NULL::date AS mphil_date_submission_due, NULL::date AS mphil_date_submitted, NULL::date AS mphil_date_awarded, NULL::date AS date_registered_for_phd, NULL::text AS phd_thesis_title_html, NULL::date AS phd_date_title_approved, NULL::date AS date_phd_submission_due, NULL::date AS phd_four_year_submission_date, NULL::date AS phd_date_submitted, NULL::date AS phd_date_examiners_appointed, NULL::date AS phd_date_of_viva, NULL::date AS phd_date_awarded, NULL::bigint AS co_supervisor_id, NULL::bigint AS mentor_id, NULL::bigint AS co_mentor_id, NULL::date AS next_mentor_meeting_due, NULL::text AS current_funding, NULL::text AS fees_funding, NULL::text AS research_grant_number, NULL::text AS part_iii_project_title_html, NULL::boolean AS paid_by_university, NULL::date AS date_of_first_probation_meeting, NULL::date AS date_of_second_probation_meeting, NULL::date AS date_of_third_probation_meeting, NULL::date AS date_probation_letters_sent, NULL::text AS probation_period, NULL::text AS emplid_number, NULL::date AS next_review_due, NULL::text AS timing_of_reviews, NULL::real AS transferable_skills_days_1st_year, NULL::real AS transferable_skills_days_2nd_year, NULL::real AS transferable_skills_days_3rd_year, NULL::real AS transferable_skills_days_4th_year, _all_roles.status
                                           FROM erasmus_socrates_studentship e
                                      LEFT JOIN _all_roles_v12 _all_roles ON e.id = _all_roles.role_id
                                     WHERE _all_roles.role_tablename = 'erasmus_socrates_studentship'::text)
                        UNION 
                                 SELECT p.person_id, p.start_date, p.intended_end_date, p.end_date, NULL::date AS funding_end_date, false AS chem, _all_roles.post_category, NULL::text AS job_title, NULL::bigint AS manager_id, NULL::text AS progress_notes, p.supervisor_id, NULL::text AS university, NULL::text AS gaf_number, NULL::bigint AS postgraduate_studentship_type_id, NULL::text AS cpgs_title_html, NULL::text AS mphil_title_html, NULL::text AS msc_title_html, NULL::date AS cpgs_or_mphil_date_submission_due, NULL::date AS cpgs_or_mphil_date_submitted, NULL::date AS cpgs_or_mphil_date_awarded, NULL::date AS mphil_date_submission_due, NULL::date AS mphil_date_submitted, NULL::date AS mphil_date_awarded, NULL::date AS date_registered_for_phd, NULL::text AS phd_thesis_title_html, NULL::date AS phd_date_title_approved, NULL::date AS date_phd_submission_due, NULL::date AS phd_four_year_submission_date, NULL::date AS phd_date_submitted, NULL::date AS phd_date_examiners_appointed, NULL::date AS phd_date_of_viva, NULL::date AS phd_date_awarded, NULL::bigint AS co_supervisor_id, NULL::bigint AS mentor_id, NULL::bigint AS co_mentor_id, NULL::date AS next_mentor_meeting_due, NULL::text AS current_funding, NULL::text AS fees_funding, NULL::text AS research_grant_number, p.project_title AS part_iii_project_title_html, NULL::boolean AS paid_by_university, NULL::date AS date_of_first_probation_meeting, NULL::date AS date_of_second_probation_meeting, NULL::date AS date_of_third_probation_meeting, NULL::date AS date_probation_letters_sent, NULL::text AS probation_period, NULL::text AS emplid_number, NULL::date AS next_review_due, NULL::text AS timing_of_reviews, NULL::real AS transferable_skills_days_1st_year, NULL::real AS transferable_skills_days_2nd_year, NULL::real AS transferable_skills_days_3rd_year, NULL::real AS transferable_skills_days_4th_year, _all_roles.status
                                   FROM part_iii_studentship p
                              LEFT JOIN _all_roles_v12 _all_roles ON _all_roles.role_id = p.id
                             WHERE _all_roles.role_tablename = 'part_iii_studentship'::text)
                UNION 
                         SELECT ph.person_id, ph.start_date, ph.intended_end_date, ph.end_date, ph.funding_end_date, ph.chem, _all_roles.post_category, ph.job_title, ph.supervisor_id AS manager_id, NULL::text AS progress_notes, ph.supervisor_id, NULL::text AS university, NULL::text AS gaf_number, NULL::bigint AS postgraduate_studentship_type_id, NULL::text AS cpgs_title_html, NULL::text AS mphil_title_html, NULL::text AS msc_title_html, NULL::date AS cpgs_or_mphil_date_submission_due, NULL::date AS cpgs_or_mphil_date_submitted, NULL::date AS cpgs_or_mphil_date_awarded, NULL::date AS mphil_date_submission_due, NULL::date AS mphil_date_submitted, NULL::date AS mphil_date_awarded, NULL::date AS date_registered_for_phd, NULL::text AS phd_thesis_title_html, NULL::date AS phd_date_title_approved, NULL::date AS date_phd_submission_due, NULL::date AS phd_four_year_submission_date, NULL::date AS phd_date_submitted, NULL::date AS phd_date_examiners_appointed, NULL::date AS phd_date_of_viva, NULL::date AS phd_date_awarded, NULL::bigint AS co_supervisor_id, ph.mentor_id, NULL::bigint AS co_mentor_id, ph.next_mentor_meeting_due, ph.filemaker_funding AS current_funding, NULL::text AS fees_funding, ph.research_grant_number, NULL::text AS part_iii_project_title_html, ph.paid_by_university, ph.date_of_first_probation_meeting, ph.date_of_second_probation_meeting, ph.date_of_third_probation_meeting, ph.date_probation_letters_sent, ph.probation_period, NULL::text AS emplid_number, ph.next_review_due, ph.timing_of_reviews, NULL::real AS transferable_skills_days_1st_year, NULL::real AS transferable_skills_days_2nd_year, NULL::real AS transferable_skills_days_3rd_year, NULL::real AS transferable_skills_days_4th_year, _all_roles.status
                           FROM post_history ph
                      LEFT JOIN staff_category ON ph.staff_category_id = staff_category.id
                 LEFT JOIN _all_roles_v12 _all_roles ON _all_roles.role_id = ph.id
                WHERE _all_roles.role_tablename = 'post_history'::text)
        UNION 
                 SELECT pg.person_id, pg.start_date, _all_roles.intended_end_date, _all_roles.end_date, pg.funding_end_date, true AS chem, _all_roles.post_category, NULL::text AS job_title, NULL::bigint AS manager_id, pg.progress_notes, pg.first_supervisor_id AS supervisor_id, pg.university, pg.gaf_number, pg.postgraduate_studentship_type_id, pg.cpgs_title AS cpgs_title_html, pg.mphil_title AS mphil_title_html, pg.msc_title AS msc_title_html, pg.cpgs_or_mphil_date_submission_due, pg.cpgs_or_mphil_date_submitted, pg.cpgs_or_mphil_date_awarded, pg.mphil_date_submission_due, pg.mphil_date_submitted, pg.mphil_date_awarded, pg.date_registered_for_phd, pg.phd_thesis_title AS phd_title_html, pg.phd_date_title_approved, pg.date_phd_submission_due, pg.end_of_registration_date AS phd_four_year_submission_date, pg.phd_date_submitted, pg.phd_date_examiners_appointed, pg.phd_date_of_viva, pg.phd_date_awarded, pg.second_supervisor_id AS co_supervisor_id, pg.first_mentor_id AS mentor_id, pg.second_mentor_id AS co_mentor_id, pg.next_mentor_meeting_due, pg.filemaker_funding AS current_funding, pg.filemaker_fees_funding AS fees_funding, NULL::text AS research_grant_number, NULL::text AS part_iii_project_title_html, pg.paid_through_payroll AS paid_by_university, NULL::date AS date_of_first_probation_meeting, NULL::date AS date_of_second_probation_meeting, NULL::date AS date_of_third_probation_meeting, NULL::date AS date_probation_letters_sent, NULL::text AS probation_period, pg.emplid_number, NULL::date AS next_review_due, NULL::text AS timing_of_reviews, pg.transferable_skills_days_1st_year, pg.transferable_skills_days_2nd_year, pg.transferable_skills_days_3rd_year, pg.transferable_skills_days_4th_year, _all_roles.status
                   FROM postgraduate_studentship pg
              LEFT JOIN postgraduate_studentship_type ON postgraduate_studentship_type.id = pg.postgraduate_studentship_type_id
         LEFT JOIN _all_roles_v12 _all_roles ON _all_roles.role_id = pg.id
        WHERE _all_roles.role_tablename = 'postgraduate_studentship'::text) roles ON roles.person_id = person.id
   LEFT JOIN _physical_status_v2 ON _physical_status_v2.id = person.id
  ORDER BY person.surname, person.first_names, roles.start_date;

ALTER TABLE hotwire."30_Report/Searching" OWNER TO dev;
GRANT ALL ON TABLE hotwire."30_Report/Searching" TO dev;
GRANT SELECT ON TABLE hotwire."30_Report/Searching" TO mgmt_ro;
GRANT SELECT ON TABLE hotwire."30_Report/Searching" TO hr;
GRANT ALL ON TABLE hotwire."30_Report/Searching" TO cen1001;

CREATE OR REPLACE VIEW hotwire."30_Report/Short_Searching" AS 
 SELECT a.id, a.surname, a.first_names, a.title_id, a.known_as, a.gender_id, a.ro_age, a.start_date, a.end_date, a.physical_status_id, a.funding_end_date, a.post_category, a.role_status_id, a.chem, a.registration_completed, a.clearance_cert_signed, a.email_address, a.hide_email, a.room_id, a.location, a.dept_telephone_number_id, a.research_group_id, a.supervisor_id, a.manager_id, a.paid_by_university, a.continuous_employment_start_date, a.payroll_personal_reference_number, a.paper_file_details, a.ni_number, a.job_title, a.current_funding, a.research_grant_number, a.university, a.nationality_id, a.cambridge_college_id, a.cpgs_or_mphil_date_submission_due, a.cpgs_or_mphil_date_submitted, a.cpgs_or_mphil_date_awarded, a.mphil_date_submission_due, a.mphil_date_submitted, a.mphil_date_awarded, a.date_registered_for_phd, a.phd_date_title_approved, a.date_phd_submission_due, a.phd_four_year_submission_date, a.phd_date_submitted, a.phd_date_examiners_appointed, a.phd_date_of_viva, a.phd_date_awarded, a.co_supervisor_id, a.mentor_id, a.co_mentor_id, a.next_mentor_meeting_due, a.fees_funding, a.part_iii_project_title_html, a.emplid_number, a.reviewer_id, a.next_review_due, a.timing_of_reviews
   FROM ( SELECT "30_Report/Searching".id, "30_Report/Searching".surname, "30_Report/Searching".first_names, "30_Report/Searching".title_id, "30_Report/Searching".known_as, "30_Report/Searching".gender_id, date_part('year'::text, age("30_Report/Searching".date_of_birth::timestamp with time zone)) AS ro_age, "30_Report/Searching".start_date, "30_Report/Searching".end_date, "30_Report/Searching".physical_status_id, "30_Report/Searching".funding_end_date, "30_Report/Searching".post_category, "30_Report/Searching".role_status_id, "30_Report/Searching".chem, "30_Report/Searching".registration_completed, "30_Report/Searching".clearance_cert_signed, "30_Report/Searching".email_address, "30_Report/Searching".hide_email, "30_Report/Searching".room_id, "30_Report/Searching".location, "30_Report/Searching".dept_telephone_number_id, "30_Report/Searching".research_group_id, "30_Report/Searching".supervisor_id, "30_Report/Searching".manager_id, "30_Report/Searching".paid_by_university, "30_Report/Searching".continuous_employment_start_date, "30_Report/Searching".payroll_personal_reference_number, "30_Report/Searching".paper_file_details, "30_Report/Searching".ni_number, "30_Report/Searching".job_title, "30_Report/Searching".current_funding, "30_Report/Searching".research_grant_number, "30_Report/Searching".university, "30_Report/Searching".nationality_id, "30_Report/Searching".cambridge_college_id, "30_Report/Searching".cpgs_or_mphil_date_submission_due, "30_Report/Searching".cpgs_or_mphil_date_submitted, "30_Report/Searching".cpgs_or_mphil_date_awarded, "30_Report/Searching".mphil_date_submission_due, "30_Report/Searching".mphil_date_submitted, "30_Report/Searching".mphil_date_awarded, "30_Report/Searching".date_registered_for_phd, "30_Report/Searching".phd_date_title_approved, "30_Report/Searching".date_phd_submission_due, "30_Report/Searching".phd_four_year_submission_date, "30_Report/Searching".phd_date_submitted, "30_Report/Searching".phd_date_examiners_appointed, "30_Report/Searching".phd_date_of_viva, "30_Report/Searching".phd_date_awarded, "30_Report/Searching".co_supervisor_id, "30_Report/Searching".mentor_id, "30_Report/Searching".co_mentor_id, "30_Report/Searching".next_mentor_meeting_due, "30_Report/Searching".fees_funding, "30_Report/Searching".part_iii_project_title_html, "30_Report/Searching".emplid_number, "30_Report/Searching".reviewer_id, "30_Report/Searching".next_review_due, "30_Report/Searching".timing_of_reviews
           FROM hotwire."30_Report/Searching") a
  ORDER BY a.surname, a.first_names, a.start_date;

ALTER TABLE hotwire."30_Report/Short_Searching" OWNER TO dev;
GRANT ALL ON TABLE hotwire."30_Report/Short_Searching" TO dev;
GRANT ALL ON TABLE hotwire."30_Report/Short_Searching" TO cen1001;
GRANT SELECT ON TABLE hotwire."30_Report/Short_Searching" TO mgmt_ro;
GRANT SELECT ON TABLE hotwire."30_Report/Short_Searching" TO hr;

CREATE OR REPLACE VIEW hotwire."30_Report/Source_of_Funds" AS 
 SELECT a.id, a.surname, a.first_names, a.post_category, a.start_date, a.current_funding, a.date_registered_for_phd, a.nationality_id, a.supervisor_id
   FROM ( SELECT "30_Report/Searching".id, "30_Report/Searching".surname, "30_Report/Searching".first_names, "30_Report/Searching".post_category, "30_Report/Searching".start_date, "30_Report/Searching".current_funding, "30_Report/Searching".date_registered_for_phd, "30_Report/Searching".nationality_id, "30_Report/Searching".supervisor_id
           FROM hotwire."30_Report/Searching") a
  ORDER BY a.surname, a.first_names;

ALTER TABLE hotwire."30_Report/Source_of_Funds"
  OWNER TO dev;
GRANT ALL ON TABLE hotwire."30_Report/Source_of_Funds" TO dev;
GRANT ALL ON TABLE hotwire."30_Report/Source_of_Funds" TO cen1001;
GRANT SELECT ON TABLE hotwire."30_Report/Source_of_Funds" TO mgmt_ro;
GRANT SELECT, UPDATE, INSERT, DELETE ON TABLE hotwire."30_Report/Source_of_Funds" TO student_management;

